---
schema_version: "1"
id: 578462e6c6c44d27c89526fca2536f3ca7634b39bb11aa1aab8373825d779763
title: Shop Customers (deprecated)
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/commerce-cloud/b2c-commerce/references/generated-api-specs/ocapi-shop-customers.md
canonical_url: https://developer.salesforce.com/docs/commerce/b2c-commerce/references/ocapi-shop-customers
source_site: developer.salesforce.com
content_type: documentation
content_hash: f7b9740fd6dd259e70364b0e392018e48229bd70e519d1eae465429b767871b2
products:
  - B2C Commerce
  - Salesforce APIs
---
Shop Customers (deprecated)

# Shop Customers (deprecated)

The Shop API endpoints enable developers to build full shopper-experience applications such as storefronts. They are designed for high-scale usage, and include a number of areas such as Baskets & Orders, Customers, Products and Pricing. Shop API endpoints are typically read-only APIs, with the exception of baskets and orders.

**Version:** 25.6

## Servers

*   `https://{host}/s/{siteId}/dw/shop/v25_6`

Protocols: https.

## Security

*   `customers_auth` (basic) User authentication either for a registered or a guest customer (selectable in request body). Access via Base64 encoded customer:password string as 'Authorization: Basic' header.
*   `oauth2_application` (oauth2) Authentication flow with client ID and password with account manager.
    *   OAuth flow application (tokenUrl: https://account.demandware.com:443/dwsso/oauth2/access\_token)
    *   Scope x-info: Scopes are NOT supported. This is just a dummy, because the 'scopes' field is required.
*   `client_id` (apiKey) Add client ID for application identification. Alternative as 'client\_id' query parameter.
    *   API key in header: x-dw-client-id

## Operations

### POST Register customer

`POST /customers`

Operation ID: `Register customer`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Registers a customer.

You must specify the login credentials, last name, and email address. This method ignores all other data, which can only be set for an existing customer. To set other values, make calls after the customer is created.

When using OAuth, don't include the password in the request. In this case, including the password throws an `InvalidPasswordException` .

When using JWT, the password is required.

Also returns the hashedLoginId for Einstein use cases.

Note: If customers are created using OCAPI call then any updated to the customer records should be done through OCAPI calls as well. The customer records created with Script API call should not be updated with OCAPI calls as the email validation is handled differently in these calls and may result in InvalidEmailException.

This endpoint may return the following faults:

*   400 - CustomerAlreadyRegisteredException - Indicates that the resource is called with JWT representing a registered customer.
*   400 - InvalidLoginException - Indicates that login doesn't match acceptance criteria.
*   400 - InvalidPasswordException - Indicates that password doesn't match acceptance criteria.
*   400 - LoginAlreadyInUseException - Indicates that the given login is already used.
*   400 - MissingEmailException - Indicates that request document does not contain email.
*   400 - MissingLastNameException - Indicates that request document does not contain last\_name.
*   400 - MissingLoginException - Indicates that request document does not contain login.
*   400 - MissingPasswordException - Indicates that password was not provided in JWT scenario.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `customer_registration`.

#### Responses

*   **400** `CustomerAlreadyRegisteredException` - Indicates that the resource is called with JWT representing a registered customer. or `InvalidLoginException` - Indicates that login doesn't match acceptance criteria. or `InvalidPasswordException` - Indicates that password doesn't match acceptance criteria. or `LoginAlreadyInUseException` - Indicates that the given login is already used. or `MissingEmailException` - Indicates that request document does not contain email. or `MissingLastNameException` - Indicates that request document does not contain last\_name. or `MissingLoginException` - Indicates that request document does not contain login. or `MissingPasswordException` - Indicates that password was not provided in JWT scenario.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer`.
    

### POST Get or refresh customer JWT (JSON Web Token)

`POST /customers/auth`

Operation ID: `Get or refresh customer JWT (JSON Web Token)`. Tags: customers. Security: client\_id.

Obtains a new JWT (JSON Web Token) for a guest or registered customer. Tokens are returned as a HTTP Authorization:Bearer response header entry. These kinds of request are supported, as specified by the `type` :

*   Type _guest_ \- creates a new guest (non-authenticated) customer and returns a token for the customer.
    
*   Type _credentials_ \- authenticates credentials passed in the HTTP Authorization:Basic request header, returning a token for a successfully authenticated customer, otherwise it throws an AuthenticationFailedException.
    
*   Type _session_ \- authenticates the customer (anonymous or registered) based on the _dwsid_ and _dwsecuretoken_ cookies. It returns a token for a successfully authenticated customer, otherwise it throws an AuthenticationFailedException.
    
*   Type _refresh_ \- examines the token passed in the HTTP Authorization:Bearer request header and when valid returns a new token with an updated expiry time.
    

For a request of type _credentials_ :

*   Updates profile attributes for the customer (for example, "last-visited").
    
*   Handles the maximum number of failed login attempts.
    

For a request of type _session_ :

*   The session and corresponding _dwsecuretoken_ must be active and valid. An expired session can't be used. The _dwsecuretoken_ cookie must have been used for at least one previous HTTPS request with the same _dwsid_ cookie.
    
*   Does not touch profile attributes for the registered customer (for example, "last-visited"), since this is not a real login.
    
*   Returns different tokens for multiple requests with the same session id. Means, there should be only one call per session.
    

About JWT

The token contains 3 sections:

*   the _header_ section (specifies token type and algorithm used)
    
*   the _payload_ section (contains customer information, client id, issue and expiration time)
    
*   finally the _signature_ section records the token signature.
    

A token is created and returned to the client whenever a registered customer logs in (type "credentials") or a guest customer requests it (type "guest"). The token is returned in the response header as `Authorization: Bearer --token--` The client has to include the token in the request header as `Authorization: Bearer --token--` in any follow up request. The server declines any follow up requests without a token or which cannot be verified based on the token signature or expiration time. A token nearing its expiration time should be exchanged for a new one (type "refresh"). See "API Usage > JWT" for more details on using JWT as an authentication mechanism.

This endpoint may return the following faults:

*   400 - AuthorizationBasicMissingException - Indicates that no HTTP Authorization:Basic header was provided.
*   401 - AuthenticationFailedException - Indicates in case of type _credentials_ the username is unknown or the password does not match. In case of type _session_ the session is not active anymore or the _dwsecuretoken_ value is invalid. In both cases the customer is disabled or locked.

#### Parameters

*   `Authorization` (header, string)
    *   Authorization:Basic for type `credentials`
        
    *   Authorization:Bearer for type `refresh`
        

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `auth_request`.

#### Responses

*   **400** `AuthorizationBasicMissingException` - Indicates that no HTTP Authorization:Basic header was provided.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **401** `AuthenticationFailedException` - Indicates in case of type _credentials_ the username is unknown or the password does not match. In case of type _session_ the session is not active anymore or the _dwsecuretoken_ value is invalid. In both cases the customer is disabled or locked.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer`.
    

### DELETE Invalidate an existing customer JWT (JSON Web Token)

`DELETE /customers/auth`

Operation ID: `Invalidate an existing customer JWT (JSON Web Token)`. Tags: customers. Security: client\_id; customers\_auth.

Invalidates the JWT provided in the header.

#### Parameters

*   `Authorization` (header, string) the JWT

#### Responses

*   **204**

### POST Authorize Trusted System Client

`POST /customers/auth/trustedsystem`

Operation ID: `Authorize Trusted System Client`. Tags: customers. Security: oauth2\_application; client\_id.

Obtain the JWTs for registered customers whose credentials are stored using a third party system.

*   Accepts `login_id` and `client_id`
    
*   Returns a customer object in the response body, and the JWT generated against the `client_id` in the response header. In addition, the returned response will include the hashedLoginId field for Einstein use.
    

This endpoint may return the following faults:

*   401 - AuthenticationFailedException -

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `trusted_system_auth_request`.

#### Responses

*   **401** `AuthenticationFailedException` -
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer`.
    

### GET Get customerExtProfile

`GET /customers/ext_profile`

Operation ID: `Get customerExtProfile`. Tags: customers. Security: oauth2\_application; client\_id.

Gets the customerExtProfile based on the passed in query parameters of external\_id and authentication\_provider\_id

This endpoint may return the following faults:

*   400 - MissingAuthenticationProviderException - Indicates that authentication\_provider\_id is not provided.
*   400 - MissingExternalIDException - Indicates that External\_id is not provided.

#### Parameters

*   `external_id` (query, string, required)  
    Minimum length: 1.
*   `authentication_provider_id` (query, string, required)  
    Minimum length: 1.

#### Responses

*   **400** `MissingAuthenticationProviderException` - Indicates that authentication\_provider\_id is not provided. or `MissingExternalIDException` - Indicates that External\_id is not provided.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customers_ext_profile`.
    

### POST Register customerExtProfile

`POST /customers/ext_profile`

Operation ID: `Register customerExtProfile`. Tags: customers. Security: customers\_auth; client\_id.

Register a customerExtProfile. The mandatory data are the external\_id and authentication\_provider\_id.

While using JWT the guest JWT needs to be used.

This will not be supporting hooks

This endpoint may return the following faults:

*   400 - CustomerAlreadyRegisteredException - Indicates that the resource is called with JWT representing a registered customer and not a guest JWT.
*   400 - CustomerExtProfileAlreadyExistException - Indicates that the customer external profile already exists.
*   400 - InvalidCustomerExtProfileException - Indicates that customerExtProfileCreation failed.
*   400 - InvalidEmailException - Indicates that the email sent in through the request document is not valid.
*   400 - InvalidLoginException - Indicates that login doesn't match acceptance criteria.
*   400 - LoginAlreadyInUseException - Indicates that the given login already exists.
*   400 - MissingAuthenticationProviderException - Indicates that request document does not contain authentication\_provider\_id.
*   400 - MissingExternalIDException - Indicates that request document does not contain External\_id.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `customers_ext_profile`.

#### Responses

*   **400** `CustomerAlreadyRegisteredException` - Indicates that the resource is called with JWT representing a registered customer and not a guest JWT. or `CustomerExtProfileAlreadyExistException` - Indicates that the customer external profile already exists. or `InvalidCustomerExtProfileException` - Indicates that customerExtProfileCreation failed. or `InvalidEmailException` - Indicates that the email sent in through the request document is not valid. or `InvalidLoginException` - Indicates that login doesn't match acceptance criteria. or `LoginAlreadyInUseException` - Indicates that the given login already exists. or `MissingAuthenticationProviderException` - Indicates that request document does not contain authentication\_provider\_id. or `MissingExternalIDException` - Indicates that request document does not contain External\_id.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customers_ext_profile`.
    

### POST Reset Password Token

`POST /customers/password/actions/create_reset_token`

Operation ID: `Reset Password Token`. Tags: customers. Security: oauth2\_application; client\_id.

Returns a reset password token for the passed in customer's login that will be used with the customers/reset\_password endpoint to change the customer's password.

This differs from the customers/password\_reset endpoint as it does not require or allow before or after hook processing.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - Indicates that the customer with the given login id is unknown.
*   400 - MissingLoginException - Indicates that login id is missing from the request.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `reset_password_token_request`.

#### Responses

*   **400** `InvalidCustomerException` - Indicates that the customer with the given login id is unknown. or `MissingLoginException` - Indicates that login id is missing from the request.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `reset_password_token_result`.
    

### POST Reset Customer Password

`POST /customers/password/actions/reset`

Operation ID: `Reset Customer Password`. Tags: customers. Security: oauth2\_application; client\_id.

Changes the customer's password to the new password value in the call using the reset password token that was returned from the customers/reset\_password\_token endpoint.

This differs from the customers/password\_reset endpoint as it does not require or allow before or after hook processing.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - Indicates there was a problem with the passed in values.
*   400 - InvalidPasswordException - Indicates that the rest password failed.
*   400 - MissingLoginException - Indicates that login id is missing from the request.
*   400 - MissingResetTokenException - Indicates that reset\_token is missing from the request..

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `reset_password_request`.

#### Responses

*   **204**
*   **400** `InvalidCustomerException` - Indicates there was a problem with the passed in values. or `InvalidPasswordException` - Indicates that the rest password failed. or `MissingLoginException` - Indicates that login id is missing from the request. or `MissingResetTokenException` - Indicates that reset\_token is missing from the request..
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### POST Starts a password reset process

`POST /customers/password_reset`

Operation ID: `Starts a password reset process`. Tags: customers. Security: client\_id.

First the beforePOST hook is called. After that the validation of the customer information provided in the the password reset document is performed. Then a password reset token is generated and together with the resolved customer is passed to a afterPOST hook. The customer resolution is based on the password reset request type. Both hooks are performed in a single transaction. Currently the resolution can be done by email or login. In case of an email the password reset hook is only executed if one and only one customer has been identified for that email. In the case that more than one customers have been identified for the provided email the resource does nothing.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `password_reset`.

#### Responses

*   **204**

### GET Get a Customer

`GET /customers/{customer_id}`

Operation ID: `Get a Customer`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Gets a customer.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - If customerId URL parameter does not match the verified customer represented by the JWT (not relevant when using OAuth).
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown.

#### Parameters

*   `customer_id` (path, string, required) The customer id  
    Minimum length: 1.
*   `expand` (query, array of string) The expand parameter. A comma separated list with the allowed values ( _addresses, paymentinstruments_ ).

#### Responses

*   **400** `InvalidCustomerException` - If customerId URL parameter does not match the verified customer represented by the JWT (not relevant when using OAuth).
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer`.
    

### PATCH Update a Customer

`PATCH /customers/{customer_id}`

Operation ID: `Update a Customer`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Updates a customer. This endpoint can't update login credentials.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - If customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   400 - InvalidEmailException - Indicates that the provided email is not valid.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown.

#### Parameters

*   `customer_id` (path, string, required) the customer id  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `customer`.

#### Responses

*   **400** `InvalidCustomerException` - If customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth. or `InvalidEmailException` - Indicates that the provided email is not valid.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer`.
    

### GET Get all customer addresses

`GET /customers/{customer_id}/addresses`

Operation ID: `Get all customer addresses`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Returns a sorted pageable list of all customer addresses in the address book. The default page size is 10 customer addresses. The addresses are sorted so that the preferred address is always sorted first. The remaining addresses are sorted alphabetically by ID.

When the customer cannot be found `CustomerNotFoundException` is thrown in a case of an agent but an empty result list is returned in a case of JWT.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - If customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.

#### Parameters

*   `customer_id` (path, string, required) The customer uuid  
    Minimum length: 1.
*   `start` (query, integer (int32)) The result set index to return the first instance for. Default value is 0.  
    Minimum: 0. Maximum: 999.
*   `count` (query, integer (int32)) The maximum number of instances per request. Default value is 25.  
    Minimum: 1. Maximum: 200.

#### Responses

*   **400** `InvalidCustomerException` - If customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_address_result`.
    

### POST Create customer address

`POST /customers/{customer_id}/addresses`

Operation ID: `Create customer address`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Creates a new address with the given name for the given customer.

This endpoint may return the following faults:

*   400 - AddressIdAlreadyInUseException - Indicates that the provided address name is already used for the customer.
*   400 - InvalidCustomerAddressIdException - Indicates that address name is not provided or it's blank.
*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown.

#### Parameters

*   `customer_id` (path, string, required) the id of the customer to create the address for  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `customer_address`.

#### Responses

*   **400** `AddressIdAlreadyInUseException` - Indicates that the provided address name is already used for the customer. or `InvalidCustomerAddressIdException` - Indicates that address name is not provided or it's blank. or `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_address`.
    

### GET Get customer address

`GET /customers/{customer_id}/addresses/{address_name}`

Operation ID: `Get customer address`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Retrieves a customer's address by address name.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerAddressNotFoundException - Indicates that the address with the given name in unknown for the customer with the given customer id.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown.

#### Parameters

*   `customer_id` (path, string, required) the id of the customer to retrieve the address for  
    Minimum length: 1.
*   `address_name` (path, string, required) the name of the address to retrieve  
    Minimum length: 1. Maximum length: 256.

#### Responses

*   **400** `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerAddressNotFoundException` - Indicates that the address with the given name in unknown for the customer with the given customer id. or `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_address`.
    

### DELETE Delete customer address

`DELETE /customers/{customer_id}/addresses/{address_name}`

Operation ID: `Delete customer address`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Deletes a customer's address by address name.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerAddressNotFoundException - Indicates that the address with the given name in unknown for the customer with the given customer id.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown.

#### Parameters

*   `customer_id` (path, string, required) the id of the customer to delete the address for  
    Minimum length: 1.
*   `address_name` (path, string, required) the name of the address to delete  
    Minimum length: 1. Maximum length: 256.

#### Responses

*   **204**
*   **400** `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerAddressNotFoundException` - Indicates that the address with the given name in unknown for the customer with the given customer id. or `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### PATCH Update customer address

`PATCH /customers/{customer_id}/addresses/{address_name}`

Operation ID: `Update customer address`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Updates a customer's address by address name.

This endpoint may return the following faults:

*   400 - AddressIdAlreadyInUseException - Indicates that the provided new address name is already used for the customer.
*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerAddressNotFoundException - Indicates that the address with the given name in unknown for the customer with the given customer id.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown.

#### Parameters

*   `customer_id` (path, string, required) the id of the customer to update the address for  
    Minimum length: 1.
*   `address_name` (path, string, required) the name of the address to update  
    Minimum length: 1. Maximum length: 256.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `customer_address`.

#### Responses

*   **400** `AddressIdAlreadyInUseException` - Indicates that the provided new address name is already used for the customer. or `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerAddressNotFoundException` - Indicates that the address with the given name in unknown for the customer with the given customer id. or `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_address`.
    

### POST Get an agent on behalf of customer token

`POST /customers/{customer_id}/auth`

Operation ID: `Get an agent on behalf of customer token`. Tags: customers. Security: customers\_auth; oauth2\_application.

Obtains a new agent on behalf token for a registered customer. Token is returned as a HTTP Authorization:Bearer response header entry.

A token is created and returned to the client whenever an agent with `Create_Order_On_Behalf_Of` permission calls the resource for a registered customer.

The token is returned in the response header as `Authorization: Bearer --token--` .

The client has to include the token in the request header as `Authorization: Bearer --token--`

in any follow up request, the agent will do on behalf of the customer.

About the order on behalf token

The token contains 3 sections:

*   the _header_ section (specifies token type and algorithm used)
    
*   the _payload_ section (contains customer information, client id, issue and expiration time)
    
*   finally the _signature_ section records the token signature.
    

A token nearing its expiration time should be exchanged for a new one by calling this resource once more.

#### Parameters

*   `customer_id` (path, string, required) specifies the customer to act on behalf of  
    Minimum length: 1.

#### Responses

*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer`.
    

### GET Get customer basket

`GET /customers/{customer_id}/baskets`

Operation ID: `Get customer basket`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Gets the baskets of a customer. From v24.1 onwards, the fetched baskets will also include the customer's temporary baskets.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - if customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.

#### Parameters

*   `customer_id` (path, string, required) the id of the customer to retrieve the baskets for  
    Minimum length: 1.

#### Responses

*   **400** `InvalidCustomerException` - if customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `baskets_result`.
    

### GET Get orders of customer

`GET /customers/{customer_id}/orders`

Operation ID: `Get orders of customer`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Returns a pageable list of all customer's orders. The default page size is 10.

The sum of the values of the start and count parameters should not be more than 10000.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   400 - InvalidOrderStatusException - Thrown if specified status is unknown.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.

#### Parameters

*   `customer_id` (path, string, required) the customer uuid  
    Minimum length: 1.
*   `start` (query, integer (int32)) the result set index to return the first instance for; default value is 0  
    Minimum: 0.
*   `count` (query, integer (int32)) the maximum number of instances per request; default value is 10  
    Minimum: 1. Maximum: 200.
*   `cross-sites` (query, boolean) the flag whether all sites should be searched; ignored in case of JWT; default value is `false`
*   `from` (query, string) The from date specifying the date time range to filter orders (inclusive, null allowed, ISO8601 date time format: yyyy-MM-dd'T'HH:mmZ).
*   `until` (query, string) The until date specifying the date time range to filter orders (inclusive, null allowed, ISO8601 date time format: yyyy-MM-dd'T'HH:mmZ).
*   `status` (query, string) The order status of the orders to be retrieved. Status included: created, new, open, completed, cancelled, replaced, failed.

#### Responses

*   **400** `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth. or `InvalidOrderStatusException` - Thrown if specified status is unknown.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_order_result`.
    

### PUT Update a customer's password.

`PUT /customers/{customer_id}/password`

Operation ID: `Update a customer's password.`. Tags: customers. Security: customers\_auth; client\_id.

Updates a customer's password. The default implementation updates the password in the resource.  
Versions prior to 21.3 updated the password in the afterPUT hook, which was incompatible with the Mercury API. Starting in version 21.3, the afterPUT\_v2 hook replaces the afterPUT hook.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - If customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown.

#### Parameters

*   `customer_id` (path, string, required) the customer id  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `password_change_request`.

#### Responses

*   **204**
*   **400** `InvalidCustomerException` - If customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### POST Starts a password reset process for given customer

`POST /customers/{customer_id}/password_reset`

Operation ID: `Starts a password reset process for given customer`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Starts a password reset process. The user must be an agent logged in on behalf of a customer.

Generates a password reset token and passes it with the specified customer as the path parameter to the dw.ocapi.shop.customer.password\_reset.afterPOST hook. The hook can use the provided reset token to perform actions such as sending a reset email.

This endpoint may return the following faults:

*   404 - CustomerNotFoundException - Indicates that the customer specified was not found.

#### Parameters

*   `customer_id` (path, string, required) the id of the customer  
    Minimum length: 1.

#### Responses

*   **204**
*   **404** `CustomerNotFoundException` - Indicates that the customer specified was not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### GET Get customer payment instruments

`GET /customers/{customer_id}/payment_instruments`

Operation ID: `Get customer payment instruments`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Gets customer payment instruments for an customer. Can be limited to a specific payment method by providing query parameter `payment_method_id` .

When the customer cannot be found `CustomerNotFoundException` is thrown in a case of an agent but an empty result list is returned in a case of JWT.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.

#### Parameters

*   `customer_id` (path, string, required) the id of the customer to retrieve the payment instruments for  
    Minimum length: 1.
*   `payment_method_id` (query, string) the id of the payment method, if null - all payment instruments are retrieved

#### Responses

*   **400** `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_payment_instrument_result`.
    

### POST Add payment instrument for customer

`POST /customers/{customer_id}/payment_instruments`

Operation ID: `Add payment instrument for customer`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Adds a payment instrument to a customer. Note that it can't update the read-only `credit_card_token` on a `payment_card` record.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown.

#### Parameters

*   `customer_id` (path, string, required) the id of the customer  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `customer_payment_instrument_request`.

#### Responses

*   **400** `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_payment_instrument`.
    

### GET Get customer payment instrument

`GET /customers/{customer_id}/payment_instruments/{payment_instrument_id}`

Operation ID: `Get customer payment instrument`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Retrieves a customer's payment instrument by its id.

This endpoint may return the following faults:

*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.
*   404 - PaymentInstrumentNotFoundException - Indicates that the payment instrument with the given id is unknown for the customer with the given customer id.

#### Parameters

*   `customer_id` (path, string, required) the id of the customer to retrieve the payment instrument for  
    Minimum length: 1.
*   `payment_instrument_id` (path, string, required) the id of the payment instrument to be retrievedCustomer  
    Minimum length: 1.

#### Responses

*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site. or `PaymentInstrumentNotFoundException` - Indicates that the payment instrument with the given id is unknown for the customer with the given customer id.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_payment_instrument`.
    

### DELETE Delete customer payment instrument

`DELETE /customers/{customer_id}/payment_instruments/{payment_instrument_id}`

Operation ID: `Delete customer payment instrument`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Deletes a customer's payment instrument.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.

#### Parameters

*   `customer_id` (path, string, required) the id of the customer to delete the payment instrument for  
    Minimum length: 1.
*   `payment_instrument_id` (path, string, required) the id of the payment instrument to be deleted  
    Minimum length: 1.

#### Responses

*   **204**
*   **400** `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### GET Get customer product lists

`GET /customers/{customer_id}/product_lists`

Operation ID: `Get customer product lists`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Returns all customer product lists in a paginated manner.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.

#### Parameters

*   `customer_id` (path, string, required)
    
    *   The customer id.
    
      
    Minimum length: 1.
*   `expand` (query, array of string)
    *   The possible expansions - product, images, availability. For images and availability the product has to be expanded as well.
*   `start` (query, integer (int32))
    
    *   The start of the product List
    
      
    Minimum: 0.
*   `count` (query, integer (int32))
    
    *   The count returned per page
    
      
    Minimum: 1. Maximum: 200.

#### Responses

*   **400** `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_product_list_result`.
    

### POST Create customer product list

`POST /customers/{customer_id}/product_lists`

Operation ID: `Create customer product list`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Creates a customer product list.

This endpoint may return the following faults:

*   400 - InvalidAddressLinkException - Indicates that the id of the given address link does not reference an address of the current customer.
*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   400 - InvalidProductListTypeException - Indicates that there was no or an invalid type given for the to be created product list.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.

#### Parameters

*   `customer_id` (path, string, required) The customer id.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `customer_product_list`.

#### Responses

*   **400** `InvalidAddressLinkException` - Indicates that the id of the given address link does not reference an address of the current customer. or `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth. or `InvalidProductListTypeException` - Indicates that there was no or an invalid type given for the to be created product list.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_product_list`.
    

### GET Get customer product list

`GET /customers/{customer_id}/product_lists/{list_id}`

Operation ID: `Get customer product list`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Returns a customer product list of the given customer.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.
*   404 - ProductListNotFoundException - Indicates that the product list with the given list id is unknown for the site and the customer.

#### Parameters

*   `customer_id` (path, string, required) The customer id.  
    Minimum length: 1.
*   `list_id` (path, string, required) The product list id.  
    Minimum length: 1. Maximum length: 28.
*   `expand` (query, array of string) The possible expansions - product, images, availability. For images and availability the product has to be expanded as well.

#### Responses

*   **400** `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site. or `ProductListNotFoundException` - Indicates that the product list with the given list id is unknown for the site and the customer.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_product_list`.
    

### DELETE Delete customer product list

`DELETE /customers/{customer_id}/product_lists/{list_id}`

Operation ID: `Delete customer product list`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Deletes a customer product list.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.
*   404 - ProductListNotFoundException - Indicates that the product list with the given list id is unknown for the site and the customer.

#### Parameters

*   `customer_id` (path, string, required) The customer id.  
    Minimum length: 1.
*   `list_id` (path, string, required) The product list id.  
    Minimum length: 1. Maximum length: 28.

#### Responses

*   **204**
*   **400** `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site. or `ProductListNotFoundException` - Indicates that the product list with the given list id is unknown for the site and the customer.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### PATCH Change customer product list

`PATCH /customers/{customer_id}/product_lists/{list_id}`

Operation ID: `Change customer product list`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Changes a product list. Changeable properties are the name, description and if the list is public.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.
*   404 - ProductListNotFoundException - Indicates that the product list with the given list id is unknown for the site and the customer.

#### Parameters

*   `customer_id` (path, string, required) The customer id.  
    Minimum length: 1.
*   `list_id` (path, string, required) The product list id.  
    Minimum length: 1. Maximum length: 28.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `customer_product_list`.

#### Responses

*   **400** `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site. or `ProductListNotFoundException` - Indicates that the product list with the given list id is unknown for the site and the customer.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_product_list`.
    

### GET Get items of customer's product list

`GET /customers/{customer_id}/product_lists/{list_id}/items`

Operation ID: `Get items of customer's product list`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Returns a pageable list of all items of a customer's product list. The default page size is 10.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.
*   404 - ProductListNotFoundException - Indicates that the product list with the given list id is unknown for the site and the customer.

#### Parameters

*   `customer_id` (path, string, required) The id of the customer to retrieve the product list items for.  
    Minimum length: 1.
*   `list_id` (path, string, required) The id of the product list.  
    Minimum length: 1. Maximum length: 28.
*   `expand` (query, array of string) The possible expansions - product, images, availability. For images and availability the product has to be expanded as well.
*   `start` (query, integer (int32)) The result set index to return the first instance for; default value is 0.  
    Minimum: 0.
*   `count` (query, integer (int32)) The maximum number of instances per request; default value is 10.  
    Minimum: 1. Maximum: 200.

#### Responses

*   **400** `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site. or `ProductListNotFoundException` - Indicates that the product list with the given list id is unknown for the site and the customer.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_product_list_item_result`.
    

### POST Add item to customer's product list

`POST /customers/{customer_id}/product_lists/{list_id}/items`

Operation ID: `Add item to customer's product list`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Adds an item to the customer's product list. Considered values from the request body are:

*   **type** : a valid type, mandatory. This is the type of the item to be added to the customer's product list.
    
*   **priority** : This is the priority of the item to be added to the customer's product list.
    
*   **public** : This is the flag whether the item to be added to the customer's product list is public.
    
*   **product\_id** : a valid product id, used for `product` item type only. This is the id (sku) of the product related to the item to be added to the customer's product list. It is mandatory for `product` item type and it must be a valid product id, otherwise `ProductListProductIdMissingException` or `ProductListProductNotFoundException` will be thrown.
    
*   **quantity** : used for `product` item type only. This is the quantity of the item to be added to the customer's product list.
    
*   **custom properties in the form c\_ < CUSTOM\_NAME >** : the custom property must correspond to a custom attribute ( < CUSTOM\_NAME > ) defined for ProductListItem. The value of this property must be valid for the type of custom attribute defined for ProductListItem.
    

This endpoint may return the following faults:

*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   400 - ProductListDuplicateGiftCertificateException - Indicates that the customer product list already has gift certificate item.
*   400 - ProductListItemTypeMissingException - Indicates that type property in request body is not provided.
*   400 - ProductListProductIdMissingException - Indicates that product property in request body is not provided.
*   400 - ProductListProductNotFoundException - Indicates that the product with the provided id is unknown.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.
*   404 - ProductListNotFoundException - Indicates that the product list with the given list id is unknown for the site and the customer.

#### Parameters

*   `customer_id` (path, string, required) The id of the customer - owner of the product list.  
    Minimum length: 1.
*   `list_id` (path, string, required) The id of the product list  
    Minimum length: 1. Maximum length: 28.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `customer_product_list_item`.

#### Responses

*   **400** `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth. or `ProductListDuplicateGiftCertificateException` - Indicates that the customer product list already has gift certificate item. or `ProductListItemTypeMissingException` - Indicates that type property in request body is not provided. or `ProductListProductIdMissingException` - Indicates that product property in request body is not provided. or `ProductListProductNotFoundException` - Indicates that the product with the provided id is unknown.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site. or `ProductListNotFoundException` - Indicates that the product list with the given list id is unknown for the site and the customer.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_product_list_item`.
    

### GET Get an item of a customer product list

`GET /customers/{customer_id}/product_lists/{list_id}/items/{item_id}`

Operation ID: `Get an item of a customer product list`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Returns an item of a customer product list.

This endpoint may return the following faults:

*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.
*   404 - ProductListItemNotFoundException - Indicates that the product list item with the given item id is unknown for the site, the customer and the product list.
*   404 - ProductListNotFoundException - Indicates that the product list with the given list id is unknown for the site and the customer.

#### Parameters

*   `customer_id` (path, string, required) The id of the customer to retrieve the product list items for.  
    Minimum length: 1.
*   `list_id` (path, string, required) The id of the product list.  
    Minimum length: 1. Maximum length: 28.
*   `item_id` (path, string, required) The id of the product list item to retrieve.  
    Minimum length: 1. Maximum length: 28.
*   `expand` (query, array of string) The possible expansions - product, images, availability. For images and availability the product has to be expanded as well.

#### Responses

*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site. or `ProductListItemNotFoundException` - Indicates that the product list item with the given item id is unknown for the site, the customer and the product list. or `ProductListNotFoundException` - Indicates that the product list with the given list id is unknown for the site and the customer.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_product_list_item`.
    

### DELETE Remove item from customer's product list

`DELETE /customers/{customer_id}/product_lists/{list_id}/items/{item_id}`

Operation ID: `Remove item from customer's product list`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Removes an item from a customer product list.

This endpoint may return the following faults:

*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.
*   404 - ProductListItemNotFoundException - Indicates that the product list item with the given item id is unknown for the site, the customer and the product list.
*   404 - ProductListNotFoundException - Indicates that the product list with the given list id is unknown for the site and the customer.

#### Parameters

*   `customer_id` (path, string, required) The id of the owner of the product list  
    Minimum length: 1.
*   `list_id` (path, string, required) The id of the product list.  
    Minimum length: 1. Maximum length: 28.
*   `item_id` (path, string, required) The id of the product list item to delete.  
    Minimum length: 1. Maximum length: 28.

#### Responses

*   **204**
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site. or `ProductListItemNotFoundException` - Indicates that the product list item with the given item id is unknown for the site, the customer and the product list. or `ProductListNotFoundException` - Indicates that the product list with the given list id is unknown for the site and the customer.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### PATCH Update customer's product list item

`PATCH /customers/{customer_id}/product_lists/{list_id}/items/{item_id}`

Operation ID: `Update customer's product list item`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Updates an item of a customer's product list. Considered values from the request body are:

*   **priority** : This is the priority of the customer's product list item.
    
*   **public** : This is the flag whether the customer's product list item is public.
    
*   **quantity** : used for `product` item type only. This is the quantity of the customer's product list item.
    
*   **custom properties in the form c\_ < CUSTOM\_NAME >** : the custom property must correspond to a custom attribute ( < CUSTOM\_NAME > ) defined for ProductListItem. The value of this property must be valid for the type of custom attribute defined for ProductListItem.
    

This endpoint may return the following faults:

*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.
*   404 - ProductListItemNotFoundException - Indicates that the product list item with the given item id is unknown for the site, the customer and the product list.
*   404 - ProductListNotFoundException - Indicates that the product list with the given list id is unknown for the site and the customer.

#### Parameters

*   `customer_id` (path, string, required) The id of the owner of the product list.  
    Minimum length: 1.
*   `list_id` (path, string, required) The id of the product list.  
    Minimum length: 1. Maximum length: 28.
*   `item_id` (path, string, required) The id of the product list item to update.  
    Minimum length: 1. Maximum length: 28.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `customer_product_list_item`.

#### Responses

*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site. or `ProductListItemNotFoundException` - Indicates that the product list item with the given item id is unknown for the site, the customer and the product list. or `ProductListNotFoundException` - Indicates that the product list with the given list id is unknown for the site and the customer.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_product_list_item`.
    

### GET Get the purchases of a customer product list item

`GET /customers/{customer_id}/product_lists/{list_id}/items/{item_id}/purchases`

Operation ID: `Get the purchases of a customer product list item`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Returns a list of all purchases of an item from a customer's product list.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.
*   404 - ProductListItemNotFoundException - Indicates that the product list item with the given item id is unknown for the site, the customer and the product list.
*   404 - ProductListNotFoundException - Indicates that the product list with the given list id is unknown for the site and the customer.

#### Parameters

*   `customer_id` (path, string, required) The id of the customer to retrieve the product list item purchases for.  
    Minimum length: 1.
*   `list_id` (path, string, required) The id of the product list.  
    Minimum length: 1. Maximum length: 28.
*   `item_id` (path, string, required) The id of the product list item to retrieve from.  
    Minimum length: 1. Maximum length: 28.

#### Responses

*   **400** `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site. or `ProductListItemNotFoundException` - Indicates that the product list item with the given item id is unknown for the site, the customer and the product list. or `ProductListNotFoundException` - Indicates that the product list with the given list id is unknown for the site and the customer.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_product_list_item_purchase_result`.
    

### POST Add a purchase to an item on a customer product list

`POST /customers/{customer_id}/product_lists/{list_id}/items/{item_id}/purchases`

Operation ID: `Add a purchase to an item on a customer product list`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Adds a purchase to an item in the customer's product list. Considered values from the request body are:

*   **purchaser\_name** : name of the purchaser, mandatory. This is the full name of the purchaser of this product list item.
    
*   **quantity** : amount purchased, mandatory. This is the quantity of the items purchased from the product list.
    
*   **custom properties in the form c\_ < CUSTOM\_NAME >** : the custom property must correspond to a custom attribute ( < CUSTOM\_NAME > ) defined for ProductListItemPurchase. The value of this property must be valid for the type of custom attribute defined for ProductListItemPurchase.
    

This endpoint may return the following faults:

*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.
*   404 - ProductListItemNotFoundException - Indicates that the product list item with the given item id is unknown for the site, the customer and the product list.
*   404 - ProductListNotFoundException - Indicates that the product list with the given list id is unknown for the site and the customer.

#### Parameters

*   `customer_id` (path, string, required) The id of the customer - owner of the product list.  
    Minimum length: 1.
*   `list_id` (path, string, required) The id of the product list.  
    Minimum length: 1. Maximum length: 28.
*   `item_id` (path, string, required) The id of the product list item where to add the purchase.  
    Minimum length: 1. Maximum length: 28.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `customer_product_list_item_purchase`.

#### Responses

*   **400** `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site. or `ProductListItemNotFoundException` - Indicates that the product list item with the given item id is unknown for the site, the customer and the product list. or `ProductListNotFoundException` - Indicates that the product list with the given list id is unknown for the site and the customer.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_product_list_item_purchase`.
    

### GET Get a purchase of a customer product list item

`GET /customers/{customer_id}/product_lists/{list_id}/items/{item_id}/purchases/{purchase_id}`

Operation ID: `Get a purchase of a customer product list item`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Returns a purchase of an item from a customer's product list.

This endpoint may return the following faults:

*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.
*   404 - ProductListItemNotFoundException - Indicates that the product list item with the given item id is unknown for the site, the customer and the product list.
*   404 - ProductListItemPurchaseNotFoundException - Indicates that the product list item purchase with the given purchase id is unknown for the site, customer, product list, and item.
*   404 - ProductListNotFoundException - Indicates that the product list with the given list id is unknown for the site and the customer.

#### Parameters

*   `customer_id` (path, string, required) The id of the customer to retrieve the product list items for.  
    Minimum length: 1.
*   `list_id` (path, string, required) The id of the product list.  
    Minimum length: 1. Maximum length: 28.
*   `item_id` (path, string, required) The id of the product list item to retrieve.  
    Minimum length: 1. Maximum length: 28.
*   `purchase_id` (path, string, required) The id of the product list item purchase to retrieve.  
    Minimum length: 1. Maximum length: 28.

#### Responses

*   **400** `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site. or `ProductListItemNotFoundException` - Indicates that the product list item with the given item id is unknown for the site, the customer and the product list. or `ProductListItemPurchaseNotFoundException` - Indicates that the product list item purchase with the given purchase id is unknown for the site, customer, product list, and item. or `ProductListNotFoundException` - Indicates that the product list with the given list id is unknown for the site and the customer.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_product_list_item_purchase`.
    

### PATCH Update a purchase of a customer product list item

`PATCH /customers/{customer_id}/product_lists/{list_id}/items/{item_id}/purchases/{purchase_id}`

Operation ID: `Update a purchase of a customer product list item`. Tags: customers. Security: customers\_auth; oauth2\_application; client\_id.

Updates a purchase of an item from a customer's product list. Considered values from the request body are:

*   **custom properties in the form c\_ < CUSTOM\_NAME >** : the custom property must correspond to a custom attribute ( < CUSTOM\_NAME > ) defined for ProductListItemPurchase. The value of this property must be valid for the type of custom attribute defined for ProductListItemPurchase.
    

This endpoint may return the following faults:

*   400 - InvalidCustomerException - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
*   404 - CustomerNotFoundException - Indicates that the customer with the given customer id is unknown for the site.
*   404 - ProductListItemNotFoundException - Indicates that the product list item with the given item id is unknown for the site, the customer and the product list.
*   404 - ProductListItemPurchaseNotFoundException - Indicates that the product list item purchase with the given purchase id is unknown for the site, customer, product list, and item.
*   404 - ProductListNotFoundException - Indicates that the product list with the given list id is unknown for the site and the customer.

#### Parameters

*   `customer_id` (path, string, required) The id of the customer to retrieve the product list item purchases for.  
    Minimum length: 1.
*   `list_id` (path, string, required) The id of the product list.  
    Minimum length: 1. Maximum length: 28.
*   `item_id` (path, string, required) The id of the product list item to retrieve.  
    Minimum length: 1. Maximum length: 28.
*   `purchase_id` (path, string, required) The id of the product list item purchase to retrieve.  
    Minimum length: 1. Maximum length: 28.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `customer_product_list_item_purchase`.

#### Responses

*   **400** `InvalidCustomerException` - Indicates that the customerId URL parameter does not match the verified customer represented by the JWT, not relevant when using OAuth.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerNotFoundException` - Indicates that the customer with the given customer id is unknown for the site. or `ProductListItemNotFoundException` - Indicates that the product list item with the given item id is unknown for the site, the customer and the product list. or `ProductListItemPurchaseNotFoundException` - Indicates that the product list item purchase with the given purchase id is unknown for the site, customer, product list, and item. or `ProductListNotFoundException` - Indicates that the product list with the given list id is unknown for the site and the customer.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_product_list_item_purchase`.
    

## Schemas

### customer\_registration

Document representing the registration information for a customer.

*   `customer` (_customer_, required) The customer registration information. The mandatory properties for registration are login, last name and email.
*   `password` (_string_) The password to authorize.  
    Maximum length: 4096.

_Example_

```
{
  "customer": {
    "email": "jsmith@test.com",
    "last_name": "Smith",
    "login": "jsmith"
  },
  "password": "12345!aBcD"
}
```

### fault

Document representing a fault message that is returned whenever the HTTP status code is greater than or equal to 400 (which indicates an error).

*   `arguments` (_object_)
    
    A map that provides fault arguments.
    
    Data can be used to provide error messages on the client side.
    
    Additional properties: `object`.
    
*   `cause` (_cause_)
*   `display_message_pattern` (_string_) The localized display message pattern, if the request parameter display\_locale was given
*   `message` (_string_) The message text of the java exception.
*   `stack_trace` (_string_)
*   `type` (_string_) The name of the java exception.

### customer

Document representing a customer.

*   `addresses` (_array of customer\_address_) The customer's addresses.
*   `auth_type` (_string_) The customer's authorization type (indicates if the customer is a guest or a registered customer).  
    Allowed values: `guest`, `registered`.
*   `birthday` (_string (date)_) The customer's birthday.
*   `company_name` (_string_) The customer's company name.  
    Maximum length: 256.
*   `creation_date` (_string (date-time)_, read-only) Returns the value of attribute 'creationDate'.
*   `customer_id` (_string_, read-only) The customer's number (id). Both registered and guest customers have a customer id.  
    Maximum length: 28.
*   `customer_no` (_string_) The customer's number (id). Only a registered customer has a customer number.  
    Maximum length: 100.
*   `email` (_string (email)_) The customer's email address.  
    Maximum length: 256.
*   `enabled` (_boolean_) A flag indicating whether this customer is is enabled and can log in.
*   `fax` (_string_) The customer's fax number. The length is restricted to 32 characters.  
    Maximum length: 32.
*   `first_name` (_string_) The customer's first name.  
    Maximum length: 256.
*   `gender` (_integer (int32)_) The customer's gender.  
    Allowed values: `1`, `2`. Value meanings: `1`: Male; `2`: Female.
*   `hashed_login` (_string_) The customer's hashed LoginId which is used for activity tracking for logged in customers in conjunction with visitId. This field is READ-ONLY
*   `job_title` (_string_) The customer's job title.  
    Maximum length: 256.
*   `last_login_time` (_string (date-time)_, read-only) The time when the customer last logged in.
*   `last_modified` (_string (date-time)_, read-only) Returns the value of attribute 'lastModified'.
*   `last_name` (_string_) The customer's last name.  
    Maximum length: 256.
*   `last_visit_time` (_string (date-time)_, read-only) The time when the customer last visited.
*   `login` (_string_) The customer's login.  
    Maximum length: 256.
*   `note` (_string_) The customer's note.
*   `payment_instruments` (_array of customer\_payment\_instrument_) The customer's payment instruments.
*   `phone_business` (_string_) The customer's business phone number.  
    Maximum length: 32.
*   `phone_home` (_string_) The customer's home phone number.  
    Maximum length: 32.
*   `phone_mobile` (_string_) The customer's mobile phone number.  
    Maximum length: 32.
*   `preferred_locale` (_string_, read-only) The customer's preferred locale.
*   `previous_login_time` (_string (date-time)_) The time when the customer logged in previously.
*   `previous_visit_time` (_string (date-time)_)
    
    The time when the customer last visited the store.
    
    ```
         visit.
    ```
    
*   `salutation` (_string_) The salutation to use for the customer.  
    Maximum length: 256.
*   `second_name` (_string_) The customer's second name.  
    Maximum length: 256.
*   `suffix` (_string_) The customer's suffix (for example, "Jr." or "Sr.").  
    Maximum length: 256.
*   `title` (_string_) The customer's title (for example, "Mrs" or "Mr").  
    Maximum length: 256.
*   `visit_id` (_string_) The customer's visitId. This field is READ-ONLY

_Example_

```
{
  "adresses": [
    {
      "address1": "10 Presidential Way",
      "address_id": "me",
      "city": "Woburn",
      "country_code": "US",
      "first_name": "John",
      "full_name": "John M. Smith",
      "last_name": "Smith",
      "postal_code": "01827",
      "salutation": "Mr.",
      "state_code": "MA"
    }
  ],
  "auth_type": "registered",
  "creation_date": "2015-08-20T11:30:36.000Z",
  "customer_id": "abfTWMDZOgi3JPzkHjv9IhmziI",
  "customer_no": "999",
  "email": "jsmith@salesforce.com",
  "first_name": "John",
  "gender": 1,
  "last_name": "Smith",
  "payment_instruments": [
    {
      "payment_bank_account": {
        "_type": "payment_bank_account"
      },
      "payment_card": {
        "card_type": "Visa",
        "credit_card_expired": false,
        "expiration_month": 2,
        "expiration_year": 2022,
        "holder": "John Smith",
        "masked_number": "***********ber2",
        "number_last_digits": "ber2"
      },
      "payment_instrument_id": "beybQiWcyatEEaaadniwhKxxFl",
      "payment_method_id": "CREDIT_CARD",
      "uuid": "beybQiWcyatEEaaadniwhKxxFl"
    }
  ],
  "phone_business": "234560003",
  "phone_home": "123450003",
  "phone_mobile": "345670003",
  "c_origin": "webshop"
}
```

### auth\_request

Document representing the authentication request type.

*   `type` (_string_, required) Type of authentication request: guest, login (credentials), refresh or session.  
    Allowed values: `guest`, `credentials`, `refresh`, `session`.

_Example_

```
{
  "type": "credentials"
}
```

### trusted\_system\_auth\_request

*   `client_id` (_string_, required) The client id of the shopping application to be encoded in the customer JWT. This is not the same as the OAuth Client ID used to authenticate the API call. The OAuth Client ID is the trusted/private one; this is the untrusted/public one.  
    Pattern: ^(?!\\s\*$).+.
*   `login` (_string_, required) The customer's login.  
    Pattern: ^(?!\\s\*$).+.

_Example_

```
{
  "client_id": "abdtkZzH6sqInJGIHNR1yUw90A",
  "login": "guest@email.com"
}
```

### customers\_ext\_profile

*   `authentication_provider_id` (_string_) This is a mandatory parameter  
    Maximum length: 256.
*   `creation_date` (_string (date-time)_)
*   `customer_id` (_string_)  
    Maximum length: 28.
*   `email` (_string_)  
    Maximum length: 256.
*   `external_id` (_string_) Mandatory parameter  
    Maximum length: 256.
*   `first_name` (_string_)  
    Maximum length: 256.
*   `last_modified` (_string (date-time)_)
*   `last_name` (_string_)  
    Maximum length: 256.

_Example_

```
{
  "authentication_provider_id": "Google",
  "creation_date": "2020-07-09T05:27:55.563Z",
  "customer_id": "bfqcN48dn2y4EaV9Qj5bNpVJVj",
  "email": "testCustomer@test.com",
  "external_id": "testCustomer@test.com",
  "first_name": "John",
  "last_modified": "2020-07-09T05:27:55.563Z",
  "last_name": "Doe"
}
```

### reset\_password\_token\_request

*   `login` (_string_) The login id of the customer.  
    Maximum length: 256.

### reset\_password\_token\_result

*   `email` (_string_) The email address of the customer.
*   `expires_in_minutes` (_integer (int32)_) The password reset token expire time in minutes.
*   `login` (_string_) The login id of the customer.  
    Maximum length: 256.
*   `reset_token` (_string_) The password reset token for the customer.

_Example_

```
{
  "email": "jsmith@nonexist.com",
  "expires_in_minutes": 30,
  "login": "jsmith@nonexist.com",
  "reset_token": "01a13f8e3997cf722d98fac92a05bff09c00b8568b2d98"
}
```

### reset\_password\_request

*   `login` (_string_) The login id of the customer.  
    Maximum length: 256.
*   `new_password` (_string_, required) The new password for the customer.  
    Maximum length: 4096.
*   `reset_token` (_string_) The password reset token for the customer.

_Example_

```
{
  "login": "jsmith@nonexist.com",
  "new_password": "NewPassw0rd!",
  "reset_token": "1e95f1032d7f863226e05bc10385bc841885fbb18654fe"
}
```

### password\_reset

Document representing a password reset request.

*   `identification` (_string_) The customer's login or the customer's email depending on the type value.
*   `type` (_string_) The type of customer identification.  
    Allowed values: `email`, `login`.

_Example_

```
{
  "identification": "jsmith@nonexist.com",
  "type": "email"
}
```

### customer\_address\_result

Result document containing an array of customer addresses.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of customer\_address_) The array of customer address documents.
*   `next` (_string_) The URL of the next result page.
*   `previous` (_string_) The URL of the previous result page.
*   `select` (_string_) The fields that you want to select.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 1,
  "data": [
    {
      "address1": "10 Free Way",
      "address_id": "private",
      "city": "Woburn",
      "country_code": "US",
      "first_name": "James",
      "full_name": "James Last",
      "last_name": "Last",
      "postal_code": "01827",
      "salutation": "Mr.",
      "state_code": "MA"
    }
  ],
  "next": "https://example.com/dw/shop/{version}/customers/abdlkQCKV1aEqUQoeFOwAOeD4U/addresses?count=1&start=1",
  "start": 0,
  "total": 2
}
```

### customer\_address

Document representing a customer address.

*   `address1` (_string_) The first address.  
    Maximum length: 256.
*   `address2` (_string_) The second address.  
    Maximum length: 256.
*   `address_id` (_string_) The id of the address as specified by account owner.  
    Maximum length: 256.
*   `city` (_string_) The city.  
    Maximum length: 256.
*   `company_name` (_string_) The company name.  
    Maximum length: 256.
*   `country_code` (_string_) The two-letter ISO 3166-1 (Alpha-2) country code.  
    Allowed values: `CA`, `DE`, `US`. Value meanings: `CA`: Canada; `DE`: Germany; `US`: United States. Maximum length: 2.
*   `creation_date` (_string (date-time)_, read-only) Returns the value of attribute 'creationDate'.
*   `first_name` (_string_) The first name.  
    Maximum length: 256.
*   `full_name` (_string_) The full name.  
    Maximum length: 256.
*   `job_title` (_string_) The job title.  
    Maximum length: 256.
*   `last_modified` (_string (date-time)_, read-only) Returns the value of attribute 'lastModified'.
*   `last_name` (_string_) The last name.  
    Maximum length: 256.
*   `phone` (_string_) The phone number.  
    Maximum length: 32.
*   `post_box` (_string_) The post box.  
    Maximum length: 256.
*   `postal_code` (_string_) The postal code.  
    Maximum length: 256.
*   `preferred` (_boolean_) The preferred attribute.
*   `salutation` (_string_) The salutation.  
    Maximum length: 256.
*   `second_name` (_string_) The second name.  
    Maximum length: 256.
*   `state_code` (_string_) The state code.  
    Maximum length: 256.
*   `suffix` (_string_) The suffix.  
    Maximum length: 256.
*   `suite` (_string_) The suite.  
    Maximum length: 32.
*   `title` (_string_) The title.  
    Maximum length: 256.

_Example_

```
{
  "address1": "5 Wall St",
  "address2": "24 Presidential Way",
  "address_id": "home_address",
  "city": "Burlington",
  "company_name": "Salesforce B2C Commerce",
  "country_code": "US",
  "first_name": "John",
  "full_name": "John Jim Murphy",
  "job_title": "Developer",
  "last_name": "Murphy",
  "phone": "408-555-1212",
  "post_box": "12a",
  "postal_code": "01805",
  "preferred": false,
  "salutation": "Mr.",
  "second_name": "Jim",
  "state_code": "MA",
  "title": "Dr."
}
```

### baskets\_result

Result document containing an array of baskets.

*   `baskets` (_array of basket_) The list of baskets for a customer.
*   `total` (_integer (int32)_) The total number of baskets.

_Example_

```
{
  "baskets": [
    {
      "basket_id": "bccO1aOjgEnuIaaadk7pYO2rFE"
    },
    {
      "basket_id": "bcs5vaOjgEQ9Uaaadk9zQIrXE6"
    }
  ],
  "total": 2
}
```

### customer\_order\_result

Result document containing an array of customer orders.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of order_) The array of customer order documents.
*   `next` (_string_) The URL of the next result page.
*   `previous` (_string_) The URL of the previous result page.
*   `select` (_string_) The fields that you want to select.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 1,
  "data": [
    {
      "adjusted_merchandize_total_tax": 5,
      "adjusted_shipping_total_tax": 0,
      "customer_info": {
        "customer_id": "bczhcasxVFpLdxtF05OIPEb25u",
        "customer_name": "John Smith",
        "email": "customer@sample.com"
      },
      "order_no": "00001228",
      "product_sub_total": 16.49,
      "product_total": 16.49,
      "shipping_total": 0.01,
      "shipping_total_tax": 0,
      "status": "created",
      "tax_total": 5,
      "taxation": "net"
    }
  ],
  "next": "https://example.com/dw/shop/{version}/customers/bczhcasxVFpLdxtF05OIPEb25u/orders?count=1&start=1",
  "start": 0,
  "total": 3
}
```

### password\_change\_request

Document representing a password change request.

*   `current_password` (_string_, required) The customer's current password.  
    Maximum length: 4096.
*   `password` (_string_, required) The customer's new password.  
    Maximum length: 4096.

_Example_

```
{
  "current_password": "01dpass",
  "password": "newpass"
}
```

### customer\_payment\_instrument\_result

Document representing a customer payment instrument result. The payment data contained is masked where needed for security purposes.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of customer\_payment\_instrument_) The customer payment instruments list.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 2,
  "data": [
    {
      "payment_bank_account": {
        "_type": "payment_bank_account"
      },
      "payment_card": {
        "card_type": "Visa",
        "credit_card_expired": false,
        "expiration_month": 2,
        "expiration_year": 2022,
        "holder": "John Doe",
        "masked_number": "***********1111",
        "number_last_digits": "1111"
      },
      "payment_instrument_id": "cdlPgiWbN6LM2aaadkcia6MgbA",
      "payment_method_id": "CREDIT_CARD",
      "c_strValue": "custom value 2"
    },
    {
      "bank_routing_number": "bankrouting3446",
      "gift_certificate_code_masked": "*****code",
      "payment_bank_account": {
        "drivers_license_last_digits": "e111",
        "drivers_license_state_code": "MA",
        "holder": "Joe Doe",
        "masked_drivers_license": "**********e111",
        "masked_number": "**********t111",
        "number_last_digits": "t111"
      },
      "payment_card": {
        "credit_card_expired": false
      },
      "payment_instrument_id": "cdTsgiWbN6DFEaaadkbia6MgbA",
      "payment_method_id": "OCAPI_Payment_Simple",
      "c_strValue": "custom value 1"
    }
  ],
  "total": 2
}
```

### customer\_payment\_instrument\_request

Document representing a customer payment instrument request.

*   `bank_routing_number` (_string_) The bank routing number.  
    Maximum length: 256.
*   `gift_certificate_code` (_string_) The gift certificate code.  
    Maximum length: 256.
*   `payment_bank_account` (_payment\_bank\_account\_request_) The payment bank account request data.
*   `payment_card` (_customer\_payment\_card\_request_) The customer payment card.
*   `payment_method_id` (_string_) The payment method id. Optional if a customer payment instrument id is specified.  
    Maximum length: 256.

_Example_

```
{
  "bank_routing_number": "bankrouting3776",
  "gift_certificate_code": "gift_code7",
  "payment_card": {
    "card_type": "MasterCard",
    "expiration_month": 7,
    "expiration_year": 2027,
    "holder": "Joe Doe",
    "issue_number": "i117",
    "number": "1234567",
    "valid_from_month": 8,
    "valid_from_year": 2007
  },
  "payment_method_id": "OCAPI_Payment_Simple",
  "c_strValue": "custom value 7"
}
```

### customer\_payment\_instrument

Document representing a customer payment instrument.

*   `bank_routing_number` (_string_) The bank routing number.  
    Maximum length: 256.
*   `creation_date` (_string (date-time)_, read-only) Returns the value of attribute 'creationDate'.
*   `last_modified` (_string (date-time)_, read-only) Returns the value of attribute 'lastModified'.
*   `masked_gift_certificate_code` (_string_) The masked gift certificate code.
*   `payment_bank_account` (_payment\_bank\_account_) The payment bank account.
*   `payment_card` (_payment\_card_) The payment card.
*   `payment_instrument_id` (_string_) The payment instrument ID.
*   `payment_method_id` (_string_) The payment method id. Optional if a customer payment instrument id is specified.  
    Maximum length: 256.

_Example_

```
{
  "bank_routing_number": "bankrouting3776",
  "gift_certificate_code_masked": "******ode7",
  "payment_bank_account": {
    "_type": "payment_bank_account"
  },
  "payment_card": {
    "card_type": "MasterCard",
    "credit_card_expired": false,
    "expiration_month": 7,
    "expiration_year": 2027,
    "holder": "Joe Doe",
    "issue_number": "i117",
    "masked_number": "***4567",
    "number_last_digits": "4567",
    "valid_from_month": 8,
    "valid_from_year": 2007
  },
  "payment_instrument_id": "cdOLciWbOsYl6aaadkwcsx9xHH",
  "payment_method_id": "OCAPI_Payment_Simple",
  "c_strValue": "custom value 7"
}
```

### customer\_product\_list\_result

Document representing a customer product lists result.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of customer\_product\_list_) The customer product lists.
*   `next` (_string_)
*   `previous` (_string_)
*   `start` (_integer (int32)_)  
    Minimum: 0.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 2,
  "data": [
    {
      "creation_date": "2020-07-29T22:30:43.000Z",
      "event": {
        "_type": "product_list_event"
      },
      "id": "0000073597bbf8c7604dce8f2c",
      "items_link": {
        "link": "https://example.com/s/SiteGenesis/dw/shop/{version}/customers/acXvoeW9o2g9SSiaHDHjnm7Pvc/product_lists/0000073597bbf8c7604dce8f2c/items?start=0&count=2",
        "title": "0 items"
      },
      "last_modified": "2020-07-29T22:30:44.000Z",
      "public": false,
      "type": "wish_list"
    },
    {
      "creation_date": "2020-07-29T22:30:42.000Z",
      "event": {
        "_type": "product_list_event"
      },
      "id": "0000407a34e39368119d1db05c",
      "items_link": {
        "link": "https://example.com/s/SiteGenesis/dw/shop/{version}/customers/acXvoeW9o2g9SSiaHDHjnm7Pvc/product_lists/0000407a34e39368119d1db05c/items?start=0&count=2",
        "title": "0 items"
      },
      "last_modified": "2020-07-29T22:30:44.000Z",
      "public": false,
      "type": "wish_list"
    }
  ],
  "next": "https://localhost/s/SiteGenesis/dw/shop/{version}/customers/acXvoeW9o2g9SSiaHDHjnm7Pvc/product_lists?start=2&count=2",
  "start": 0,
  "total": 4
}
```

### customer\_product\_list

Document representing a customer product List.

*   `co_registrant` (_customer\_product\_list\_registrant_) The coRegistrant of this product list.
*   `creation_date` (_string (date-time)_) Returns the value of attribute 'creationDate'.
*   `current_shipping_address_link` (_customer\_address\_link_) The resource link to the current shipping address of this customer product list.
*   `customer_product_list_items` (_array of customer\_product\_list\_item_) The list of customer product list items.
*   `description` (_string_) The description of this product list.
*   `event` (_product\_list\_event_) The event of this product list.
*   `id` (_string_) The id of this product list.  
    Minimum length: 1.
*   `items_link` (_customer\_product\_list\_item\_link_) The resource link to the items of this customer product list.
*   `last_modified` (_string (date-time)_) Returns the value of attribute 'lastModified'.
*   `name` (_string_) The name of this product list.
*   `post_event_shipping_address_link` (_customer\_address\_link_) The resource link to the post event shipping address of this customer product list.
*   `product_list_shipping_address` (_product\_list\_shipping\_address_) The abbreviated shipping address of this product list representing what anonymous user can see.
*   `public` (_boolean_) Indicates whether the owner made this product list available for access by other customers.
*   `registrant` (_customer\_product\_list\_registrant_) The registrant of this product list.
*   `shipping_address_link` (_customer\_address\_link_) The resource link to the shipping address of this customer product list.
*   `type` (_string_) The type of the product list.  
    Allowed values: `wish_list`, `gift_registry`, `shopping_list`, `custom_1`, `custom_2`, `custom_3`.

_Example_

```
{
  "co_registrant": {
    "email": "janedoe@example.com",
    "first_name": "Jane",
    "last_name": "Doe",
    "role": "Bride"
  },
  "description": "our productlist",
  "event": {
    "city": "Washington",
    "country": "US",
    "date": "2015-07-30T00:00Z",
    "state": "DC",
    "type": "Wedding"
  },
  "id": "bb151cd88655b081acc1fa85c6",
  "items_link": {
    "link": "https://example.com/dw/shop/{version}/customers/abKvXV2tYXMZPTdDwPXgx031cd/product_lists/bb151cd88655b081acc1fa85c6/items",
    "title": "0 items"
  },
  "name": "OurProductList",
  "public": false,
  "registrant": {
    "email": "johndoe@example.com",
    "first_name": "John",
    "last_name": "Doe",
    "role": "Groom"
  },
  "type": "wish_list"
}
```

### customer\_product\_list\_item\_result

Document representing a customer product list items result.

*   `count` (_integer (int32)_)
*   `data` (_array of customer\_product\_list\_item_) The customer product list items.
*   `next` (_string_) The URL of the next result page.
*   `previous` (_string_) The URL of the previous result page.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_)

_Example_

```
{
  "count": 2,
  "data": [
    {
      "id": "ebe04a8c6be5c01a5dac9e50ac",
      "priority": 4,
      "product_details_link": {
        "link": "https://example.com/dw/shop/{version}/products/008884303989",
        "title": "Platinum Blue Stripes Easy Care Fitted Shirt"
      },
      "product_id": "008884303989",
      "public": true,
      "purchased_quantity": 0,
      "quantity": 2,
      "type": "product"
    },
    {
      "id": "f33bfc1a99e64c79ddfbb49b19",
      "priority": 2,
      "public": false,
      "purchased_quantity": 0,
      "type": "gift_certificate"
    }
  ],
  "start": 0,
  "total": 2
}
```

### customer\_product\_list\_item

Document representing a customer product list item.

*   `id` (_string_) The id of this product list item.
*   `priority` (_integer (int32)_) The priority of the item.
*   `product` (_product_) The product item
*   `product_details_link` (_product\_simple\_link_) A link to the product.
*   `product_id` (_string_) The id of the product.
*   `public` (_boolean_) Is this product list item available for access by other customers?
*   `purchased_quantity` (_number (double)_) The quantity of products already purchased.
*   `quantity` (_number (double)_) The quantity of this product list item.  
    Minimum: 0.
*   `type` (_string_) The type of the item.  
    Allowed values: `product`, `gift_certificate`.

_Example_

```
{
  "id": "1d447daa4d25805fd682bd4ce1",
  "priority": 4,
  "product_details_link": {
    "link": "https://example.com/dw/shop/{version}/products/008884303989",
    "title": "Platinum Blue Stripes Easy Care Fitted Shirt"
  },
  "product_id": "008884303989",
  "public": true,
  "purchased_quantity": 0,
  "quantity": 2,
  "type": "product"
}
```

### customer\_product\_list\_item\_purchase\_result

Document representing a customer product list purchases result.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of customer\_product\_list\_item\_purchase_) The customer product list item purchases.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 1,
  "data": [
    {
      "id": "2cebc21d3698a82efae72acff0",
[...]
